<?php

/**
 * Weekly Plugin
 *
 *
 * Created: 2007-03-06
 * Last update: 2007-04-24
 *
 * @link http://deboutv.free.fr/mantis/
 * @author DEBOUT Vincent  <deboutv@free.fr>
 */

if ( !ereg( 'plugins_page.php', $_SERVER['PHP_SELF'] ) ) {
    header( 'Location: ../../plugins_page.php' );
    exit();
}

$t_action = gpc_get_string( 'action', 'none' );
if ( $t_action == 'update' ) {
    $t_project_id = gpc_get_int( 'project_id' );
    $t_enable = gpc_get_bool( 'enable' );
    $t_html_enable = gpc_get_bool( 'html_enable' );
    $t_html_host = gpc_get_string( 'html_host', PLUGINS_WEEKLY_FROM_HOST_DEFAULT );
    $t_format = gpc_get_int( 'format' );
    $t_subject = gpc_get_string( 'subject' );
    $t_user_ids = gpc_get_int_array( 'user_id' );
    $t_end = gpc_get_int( 'end' );
    $t_period = gpc_get_int( 'period' );
    $t_boxes['unassigned'] = gpc_get_int( 'unassigned' ) . ',';
    if ( gpc_get_bool( 'unassigned_use_date' ) ) {
        $t_boxes['unassigned'] .= 'on';
    } else {
        $t_boxes['unassigned'] .= 'off';
    }
    $t_boxes['resolved'] = gpc_get_int( 'resolved' ) . ',';
    if ( gpc_get_bool( 'resolved_use_date' ) ) {
        $t_boxes['resolved'] .= 'on';
    } else {
        $t_boxes['resolved'] .= 'off';
    }
    $t_boxes['recent_mod'] = gpc_get_int( 'recent_mod' ) . ',';
    if ( gpc_get_bool( 'recent_mod_use_date' ) ) {
        $t_boxes['recent_mod'] .= 'on';
    } else {
        $t_boxes['recent_mod'] .= 'off';
    }
    $t_boxes['feedback'] = gpc_get_int( 'feedback' ) . ',';
    if ( gpc_get_bool( 'feedback_use_date' ) ) {
        $t_boxes['feedback'] .= 'on';
    } else {
        $t_boxes['feedback'] .= 'off';
    }
    $t_boxes['verify'] = gpc_get_int( 'verify' ) . ',';
    if ( gpc_get_bool( 'verify_use_date' ) ) {
        $t_boxes['verify'] .= 'on';
    } else {
        $t_boxes['verify'] .= 'off';
    }
    $t_bug_number = gpc_get_int( 'bug_number' );
    $t_excluded_bugs = gpc_get_string( 'excluded_bugs', PLUGINS_WEEKLY_EXCLUDED_BUGS_DEFAULT );
    config_set( 'plugins_weekly_enable', $t_enable, NO_USER, $t_project_id );
    config_set( 'plugins_weekly_html_enable', $t_html_enable, NO_USER, $t_project_id );
    config_set( 'plugins_weekly_html_host', $t_html_host, NO_USER, $t_project_id );
    config_set( 'plugins_weekly_format', $t_format, NO_USER, $t_project_id );
    config_set( 'plugins_weekly_subject_title', $t_subject, NO_USER, $t_project_id );
    config_set( 'plugins_weekly_users', $t_user_ids, NO_USER, $t_project_id );
    config_set( 'plugins_weekly_end', $t_end, NO_USER, $t_project_id );
    config_set( 'plugins_weekly_period', $t_period, NO_USER, $t_project_id );
    config_set( 'plugins_weekly_bug_number', $t_bug_number, NO_USER, $t_project_id );
    config_set( 'plugins_weekly_view_boxes', $t_boxes, NO_USER, $t_project_id );
    config_set( 'plugins_weekly_excluded_bugs', $t_excluded_bugs, NO_USER, $t_project_id );
    header( 'Location: plugins_page.php?plugin=weekly' );
    exit();
}

$t_project_id = helper_get_current_project();

$t_boxes = config_get( 'plugins_weekly_view_boxes', array( 'unassigned' => PLUGINS_WEEKLY_UNASSINGED_DEFAULT, 'resolved' => PLUGINS_WEEKLY_RESOLVED_DEFAULT, 'recent_mod' => PLUGINS_WEEKLY_RECENTLY_MODIFIED_DEFAULT, 'feedback' => PLUGINS_WEEKLY_FEEDBACK_DEFAULT, 'verify' => PLUGINS_WEEKLY_VERIFY_DEFAULT ) );
$t_box = array();
foreach( $t_boxes as $t_key => $t_value ) {
    $t_value = explode( ',', $t_value );
    $t_box[$t_key]['position'] = $t_value[0];
    $t_box[$t_key]['use_date'] = $t_value[1];
}

html_page_top1( lang_get( 'plugins_weekly_page_title' ) );
html_page_top2();

?>

<br />
<div align="center">
<?php

  echo str_replace( '%%project%%', '<b>' . project_get_name( $t_project_id ) . '</b>', lang_get( 'plugins_weekly_configuration_for_project' ) );

?>
  <br /><br />
  <form name="plugins_weekly" method="post" action="plugins_page.php">
    <input type="hidden" name="action" value="update" />
    <input type="hidden" name="project_id" value="<?php echo $t_project_id ?>" />
    <input type="hidden" name="plugin" value="weekly" />
    <table class="width75" cellspacing="1">

      <!-- Enable/Disable -->
      <tr <?php echo helper_alternate_class() ?>>
        <td class="category" width="30%"><span class="required">*</span><?php echo lang_get( 'plugins_weekly_enable' ) ?></td>
        <td width="70%"><input tabindex="1" type="checkbox" name="enable"<?php check_checked( config_get( 'plugins_weekly_enable', PLUGINS_WEEKLY_ENABLE_DEFAULT ), ON ) ?>/></td>
      </tr>

      <!-- spacer -->
      <tr>
        <td class="spacer" colspan="2">&nbsp;</td>
      </tr>

      <!-- Send by browsing -->
      <tr <?php echo helper_alternate_class() ?>>
        <td class="category" width="30%"><span class="required">*</span><?php echo lang_get( 'plugins_weekly_allow_sending_by_html' ) ?></td>
        <td width="70%"><input tabindex="2" type="checkbox" name="html_enable"<?php check_checked( config_get( 'plugins_weekly_html_enable', PLUGINS_WEEKLY_HTML_ENABLE_DEFAULT ), ON ) ?>/></td>
      </tr>

      <!-- From host -->
      <tr <?php echo helper_alternate_class() ?>>
        <td class="category" width="30%"><?php echo lang_get( 'plugins_weekly_from_host' ) ?></td>
        <td width="70%"><input tabindex="3" type="input" name="html_host" value="<?php echo config_get( 'plugins_weekly_html_host', PLUGINS_WEEKLY_FROM_HOST_DEFAULT ) ?>" /></td>
      </tr>

      <!-- spacer -->
      <tr>
        <td class="spacer" colspan="2">&nbsp;</td>
      </tr>

      <!-- Format -->
      <tr <?php echo helper_alternate_class() ?>>
        <td class="category" width="30%"><span class="required">*</span><?php echo lang_get( 'plugins_weekly_format' ) ?></td>
        <td width="70%">
          <select tabindex="4" name="format">
            <option value="0"<?php check_selected( config_get( 'plugins_weekly_format', PLUGINS_WEEKLY_FORMAT_DEFAULT ), 0 ) ?>>Text</option>
            <option value="1"<?php check_selected( config_get( 'plugins_weekly_format', PLUGINS_WEEKLY_FORMAT_DEFAULT ), 1 ) ?>>HTML (<?php echo lang_get( 'plugins_weekly_not_recommended' ) ?>)</option>
            <option value="2"<?php check_selected( config_get( 'plugins_weekly_format', PLUGINS_WEEKLY_FORMAT_DEFAULT ), 2 ) ?>>Text/HTML</option>
          </select>
        </td>
      </tr>

      <!-- spacer -->
      <tr>
        <td class="spacer" colspan="2">&nbsp;</td>
      </tr>

      <!-- Subject -->
      <tr <?php echo helper_alternate_class() ?>>
        <td class="category" width="30%"><span class="required">*</span><?php echo lang_get( 'plugins_weekly_email_subject' ) ?></td>
        <td width="70%"><input tabindex="5" type="input" name="subject" size="50" value="<?php echo config_get( 'plugins_weekly_subject_title', PLUGINS_WEEKLY_SUBJECT_TITLE_DEFAULT ) ?>" /></td>
      </tr>

      <!-- End -->
      <tr <?php echo helper_alternate_class() ?>>
        <td class="category" width="30%"><span class="required">*</span><?php echo lang_get( 'plugins_weekly_offset' ) ?></td>
        <td width="70%"><input tabindex="6" type="input" name="end" size="4" value="<?php echo config_get( 'plugins_weekly_end', PLUGINS_WEEKLY_END_DEFAULT ) ?>" /> <?php echo lang_get( 'plugins_weekly_hours' ) ?></td>
      </tr>

      <!-- Period -->
      <tr <?php echo helper_alternate_class() ?>>
        <td class="category" width="30%"><span class="required">*</span><?php echo lang_get( 'plugins_weekly_period' ) ?></td>
        <td width="70%"><input tabindex="7" type="input" name="period" size="4" value="<?php echo config_get( 'plugins_weekly_period', PLUGINS_WEEKLY_PERIOD_DEFAULT ) ?>" /> <?php echo lang_get( 'plugins_weekly_days' ) ?></td>
      </tr>

      <!-- spacer -->
      <tr>
        <td class="spacer" colspan="2">&nbsp;</td>
      </tr>

      <!-- View boxes -->
      <tr <?php echo helper_alternate_class() ?>>
        <td class="category" width="30%"><span class="required">*</span><?php echo lang_get( 'plugins_weekly_unassigned' ) ?></td>
        <td width="70%">
          <input tabindex="8" type="input" name="unassigned" size="4" value="<?php echo $t_box['unassigned']['position'] ?>" />
          <input tabindex="9" type="checkbox" name="unassigned_use_date"<?php check_checked( $t_box['unassigned']['use_date'], 'on' ) ?> /> <?php echo lang_get( 'plugins_weekly_use_date_filter' ) ?>
        </td>
      </tr>

      <tr <?php echo helper_alternate_class() ?>>
        <td class="category" width="30%">
          <span class="required">*</span><?php echo lang_get( 'plugins_weekly_resolved' ) ?>
        </td>
        <td width="70%">
          <input tabindex="10" type="input" name="resolved" size="4" value="<?php echo $t_box['resolved']['position'] ?>" />
          <input tabindex="11" type="checkbox" name="resolved_use_date"<?php check_checked( $t_box['resolved']['use_date'], 'on' ) ?>/> <?php echo lang_get( 'plugins_weekly_use_date_filter' ) ?>
        </td>
      </tr>

      <tr <?php echo helper_alternate_class() ?>>
        <td class="category" width="30%"><span class="required">*</span><?php echo lang_get( 'plugins_weekly_recently_modified' ) ?></td>
        <td width="70%">
          <input tabindex="12" type="input" name="recent_mod" size="4" value="<?php echo $t_box['recent_mod']['position'] ?>" />
          <input tabindex="13" type="checkbox" name="recent_mod_use_date"<?php check_checked( $t_box['recent_mod']['use_date'], 'on' ) ?>/> <?php echo lang_get( 'plugins_weekly_use_date_filter' ) ?>
        </td>
      </tr>

      <tr <?php echo helper_alternate_class() ?>>
        <td class="category" width="30%"><span class="required">*</span><?php echo lang_get( 'plugins_weekly_feedback' ) ?></td>
        <td width="70%">
          <input tabindex="14" type="input" name="feedback" size="4" value="<?php echo $t_box['feedback']['position'] ?>" />
          <input tabindex="15" type="checkbox" name="feedback_use_date"<?php check_checked( $t_box['feedback']['use_date'], 'on' ) ?>/> <?php echo lang_get( 'plugins_weekly_use_date_filter' ) ?>
        </td>
      </tr>

      <tr <?php echo helper_alternate_class() ?>>
        <td class="category" width="30%"><span class="required">*</span><?php echo lang_get( 'plugins_weekly_verify' ) ?></td>
        <td width="70%">
          <input tabindex="16" type="input" name="verify" size="4" value="<?php echo $t_box['verify']['position'] ?>" />
          <input tabindex="17" type="checkbox" name="verify_use_date"<?php check_checked( $t_box['verify']['use_date'], 'on' ) ?>/> <?php echo lang_get( 'plugins_weekly_use_date_filter' ) ?>
        </td>
      </tr>

      <tr <?php echo helper_alternate_class() ?>>
        <td class="category" width="30%"><span class="required">*</span><?php echo lang_get( 'plugins_weekly_bug_count' ) ?></td>
        <td width="70%"><input tabindex="18" type="input" name="bug_number" size="4" value="<?php echo config_get( 'plugins_weekly_bug_number', PLUGINS_WEEKLY_BUG_NUMBER_DEFAULT ) ?>" /></td>
      </tr>

      <tr <?php echo helper_alternate_class() ?>>
        <td class="category" width="30%"><?php echo lang_get( 'plugins_weekly_excluded_bugs' ) ?></td>
        <td width="70%">
          <textarea tabindex="19" name="excluded_bugs" rows="5" cols="50"><?php echo config_get( 'plugins_weekly_excluded_bugs', PLUGINS_WEEKLY_EXCLUDED_BUGS_DEFAULT ) ?></textarea>
        </td>
      </tr>

      <!-- spacer -->
      <tr>
        <td class="spacer" colspan="2">&nbsp;</td>
      </tr>

      <!-- Send to -->
      <tr <?php echo helper_alternate_class() ?>>
        <td class="category" width="30%"><span class="required">*</span><?php echo lang_get( 'plugins_weekly_send_to' ) ?></td>
        <td width="70%">
          <select tabindex="20" name="user_id[]" multiple="multiple" size="10">
            <?php plugins_weekly_print_user_list( config_get( 'plugins_weekly_users', array() ) ) ?>

          </select>
        </td>
      </tr>

      <!-- Submit Button -->
      <tr>
        <td class="left"><span class="required"> * <?php echo lang_get( 'required' ) ?></span></td>
        <td class="center"><input tabindex="21" type="submit" class="button" value="<?php echo lang_get( 'submit_button' ) ?>" /></td>
      </tr>

    </table>
  </form>

<?php

if ( config_get( 'plugins_weekly_html_enable', PLUGINS_WEEKLY_HTML_ENABLE_DEFAULT, NO_USER, ALL_PROJECTS ) == ON || config_get( 'plugins_weekly_html_enable', PLUGINS_WEEKLY_HTML_ENABLE_DEFAULT, NO_USER, $t_project_id ) == ON ) {

?>
  <br />
  <table class="width75" cellspacing="1">
    <tr>
      <td class="form-title"><?php echo lang_get( 'plugins_weekly_links_to_send' )  ?></td>
    </tr>
      <td class="center">
<?php

$t_ip = config_get( 'plugins_weekly_html_host', PLUGINS_WEEKLY_HTML_HOST_DEFAULT, NO_USER, $t_project_id );
if ( !eregi( '^[0-9]+\.[0-9]+\.[0-9]+\.[0-9]+', $t_ip ) ) {
    $t_ip = gethostbyname( $t_ip );
}
$t_insert_br = '';
if ( config_get( 'plugins_weekly_html_enable', PLUGINS_WEEKLY_HTML_ENABLE_DEFAULT, NO_USER, $t_project_id ) == ON && $_SERVER['REMOTE_ADDR'] == $t_ip && $t_project_id != 0 ) {
    echo '        <a href="plugins/weekly/weekly_send.php?project_id=' . $t_project_id . '">' . lang_get( 'plugins_weekly_send_project_link' ) . '</a> [<a href="plugins/weekly/weekly_send.php?project_id=' . $t_project_id . '" target="_blank">^</a>]';
    $t_insert_br = '<br />' . "\n";
}
$t_ip = config_get( 'plugins_weekly_html_host', PLUGINS_WEEKLY_HTML_HOST_DEFAULT, NO_USER, ALL_PROJECTS );
if ( !eregi( '^[0-9]+\.[0-9]+\.[0-9]+\.[0-9]+', $t_ip ) ) {
    $t_ip = gethostbyname( $t_ip );
}
if ( config_get( 'plugins_weekly_html_enable', PLUGINS_WEEKLY_HTML_ENABLE_DEFAULT, NO_USER, ALL_PROJECTS ) == ON && $_SERVER['REMOTE_ADDR'] == $t_ip ) {
    echo $t_insert_br;
    echo '        <a href="plugins/weekly/weekly_send.php">' . lang_get( 'plugins_weekly_send_all_project_link' ) . '</a> [<a href="plugins/weekly/weekly_send.php" target="_blank">^</a>]';
}

?>
      </td>
    <tr>
    </tr>
  </table>
<?php

}

echo "</div>\n";

html_page_bottom1( __FILE__ );

?>
